gnu: neomutt: Update to 20170609.
[jackhill/guix/guix.git] / Makefile.am
1 # GNU Guix --- Functional package management for GNU
2 # Copyright © 2012, 2013, 2014, 2015, 2016, 2017 Ludovic Courtès <ludo@gnu.org>
3 # Copyright © 2013 Andreas Enge <andreas@enge.fr>
4 # Copyright © 2015, 2017 Alex Kost <alezost@gmail.com>
5 # Copyright © 2016 Mathieu Lirzin <mthl@gnu.org>
6 # Copyright © 2016, 2017 Mark H Weaver <mhw@netris.org>
7 # Copyright © 2017 Mathieu Othacehe <m.othacehe@gmail.com>
8 # Copyright © 2017 Leo Famulari <leo@famulari.name>
9 # Copyright © 2017 Ricardo Wurmus <rekado@elephly.net>
10 #
11 # This file is part of GNU Guix.
12 #
13 # GNU Guix is free software; you can redistribute it and/or modify it
14 # under the terms of the GNU General Public License as published by
15 # the Free Software Foundation; either version 3 of the License, or (at
16 # your option) any later version.
17 #
18 # GNU Guix is distributed in the hope that it will be useful, but
19 # WITHOUT ANY WARRANTY; without even the implied warranty of
20 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
21 # GNU General Public License for more details.
22 #
23 # You should have received a copy of the GNU General Public License
24 # along with GNU Guix. If not, see <http://www.gnu.org/licenses/>.
25
26 bin_SCRIPTS = \
27 scripts/guix
28
29 nodist_noinst_SCRIPTS = \
30 pre-inst-env \
31 test-env
32
33 # Modules that are not compiled but are installed nonetheless, such as
34 # build-side modules with unusual dependencies.
35 MODULES_NOT_COMPILED =
36
37 include gnu/local.mk
38
39 MODULES = \
40 guix/base16.scm \
41 guix/base32.scm \
42 guix/base64.scm \
43 guix/cpio.scm \
44 guix/records.scm \
45 guix/gcrypt.scm \
46 guix/hash.scm \
47 guix/pk-crypto.scm \
48 guix/pki.scm \
49 guix/combinators.scm \
50 guix/memoization.scm \
51 guix/utils.scm \
52 guix/sets.scm \
53 guix/modules.scm \
54 guix/download.scm \
55 guix/discovery.scm \
56 guix/git-download.scm \
57 guix/hg-download.scm \
58 guix/monads.scm \
59 guix/monad-repl.scm \
60 guix/gexp.scm \
61 guix/profiles.scm \
62 guix/serialization.scm \
63 guix/nar.scm \
64 guix/derivations.scm \
65 guix/grafts.scm \
66 guix/gnu-maintenance.scm \
67 guix/upstream.scm \
68 guix/licenses.scm \
69 guix/graph.scm \
70 guix/cache.scm \
71 guix/cve.scm \
72 guix/workers.scm \
73 guix/zlib.scm \
74 guix/build-system.scm \
75 guix/build-system/ant.scm \
76 guix/build-system/cargo.scm \
77 guix/build-system/cmake.scm \
78 guix/build-system/dub.scm \
79 guix/build-system/emacs.scm \
80 guix/build-system/font.scm \
81 guix/build-system/asdf.scm \
82 guix/build-system/glib-or-gtk.scm \
83 guix/build-system/gnu.scm \
84 guix/build-system/haskell.scm \
85 guix/build-system/perl.scm \
86 guix/build-system/python.scm \
87 guix/build-system/ocaml.scm \
88 guix/build-system/waf.scm \
89 guix/build-system/r.scm \
90 guix/build-system/ruby.scm \
91 guix/build-system/texlive.scm \
92 guix/build-system/trivial.scm \
93 guix/ftp-client.scm \
94 guix/http-client.scm \
95 guix/gnupg.scm \
96 guix/elf.scm \
97 guix/store.scm \
98 guix/cvs-download.scm \
99 guix/svn-download.scm \
100 guix/ui.scm \
101 guix/build/ant-build-system.scm \
102 guix/build/download.scm \
103 guix/build/cargo-build-system.scm \
104 guix/build/cmake-build-system.scm \
105 guix/build/dub-build-system.scm \
106 guix/build/emacs-build-system.scm \
107 guix/build/font-build-system.scm \
108 guix/build/asdf-build-system.scm \
109 guix/build/git.scm \
110 guix/build/hg.scm \
111 guix/build/glib-or-gtk-build-system.scm \
112 guix/build/gnu-build-system.scm \
113 guix/build/gnu-dist.scm \
114 guix/build/perl-build-system.scm \
115 guix/build/python-build-system.scm \
116 guix/build/ocaml-build-system.scm \
117 guix/build/r-build-system.scm \
118 guix/build/ruby-build-system.scm \
119 guix/build/texlive-build-system.scm \
120 guix/build/waf-build-system.scm \
121 guix/build/haskell-build-system.scm \
122 guix/build/store-copy.scm \
123 guix/build/utils.scm \
124 guix/build/union.scm \
125 guix/build/profiles.scm \
126 guix/build/pull.scm \
127 guix/build/rpath.scm \
128 guix/build/cvs.scm \
129 guix/build/svn.scm \
130 guix/build/syscalls.scm \
131 guix/build/gremlin.scm \
132 guix/build/emacs-utils.scm \
133 guix/build/java-utils.scm \
134 guix/build/lisp-utils.scm \
135 guix/build/graft.scm \
136 guix/build/bournish.scm \
137 guix/build/qt-utils.scm \
138 guix/build/make-bootstrap.scm \
139 guix/search-paths.scm \
140 guix/packages.scm \
141 guix/import/utils.scm \
142 guix/import/gnu.scm \
143 guix/import/snix.scm \
144 guix/import/cabal.scm \
145 guix/import/cran.scm \
146 guix/import/hackage.scm \
147 guix/import/elpa.scm \
148 guix/import/texlive.scm \
149 guix/scripts.scm \
150 guix/scripts/download.scm \
151 guix/scripts/perform-download.scm \
152 guix/scripts/build.scm \
153 guix/scripts/archive.scm \
154 guix/scripts/import.scm \
155 guix/scripts/package.scm \
156 guix/scripts/gc.scm \
157 guix/scripts/hash.scm \
158 guix/scripts/pack.scm \
159 guix/scripts/pull.scm \
160 guix/scripts/substitute.scm \
161 guix/scripts/authenticate.scm \
162 guix/scripts/refresh.scm \
163 guix/scripts/system.scm \
164 guix/scripts/lint.scm \
165 guix/scripts/challenge.scm \
166 guix/scripts/import/cran.scm \
167 guix/scripts/import/gnu.scm \
168 guix/scripts/import/nix.scm \
169 guix/scripts/import/hackage.scm \
170 guix/scripts/import/elpa.scm \
171 guix/scripts/import/texlive.scm \
172 guix/scripts/environment.scm \
173 guix/scripts/publish.scm \
174 guix/scripts/edit.scm \
175 guix/scripts/size.scm \
176 guix/scripts/graph.scm \
177 guix/scripts/container.scm \
178 guix/scripts/container/exec.scm \
179 guix.scm \
180 $(GNU_SYSTEM_MODULES)
181
182 if HAVE_GUILE_JSON
183
184 MODULES += \
185 guix/docker.scm \
186 guix/import/cpan.scm \
187 guix/import/crate.scm \
188 guix/import/gem.scm \
189 guix/import/github.scm \
190 guix/import/json.scm \
191 guix/import/pypi.scm \
192 guix/import/stackage.scm \
193 guix/scripts/import/crate.scm \
194 guix/scripts/import/gem.scm \
195 guix/scripts/import/pypi.scm \
196 guix/scripts/import/stackage.scm
197
198 endif
199
200 if HAVE_GUILE_SSH
201
202 MODULES += \
203 guix/ssh.scm \
204 guix/scripts/copy.scm \
205 guix/store/ssh.scm
206
207 endif HAVE_GUILE_SSH
208
209 if HAVE_GUILE_GIT
210
211 MODULES += \
212 guix/git.scm
213
214 endif HAVE_GUILE_GIT
215
216 if BUILD_DAEMON_OFFLOAD
217
218 MODULES += \
219 guix/scripts/offload.scm
220
221 endif BUILD_DAEMON_OFFLOAD
222
223 # Internal modules with test suite support.
224 dist_noinst_DATA = guix/tests.scm guix/tests/http.scm
225
226 # Auxiliary files for packages.
227 AUX_FILES = \
228 gnu/packages/aux-files/emacs/guix-emacs.el \
229 gnu/packages/aux-files/linux-libre/4.11-i686.conf \
230 gnu/packages/aux-files/linux-libre/4.11-x86_64.conf \
231 gnu/packages/aux-files/linux-libre/4.9-i686.conf \
232 gnu/packages/aux-files/linux-libre/4.9-x86_64.conf \
233 gnu/packages/aux-files/linux-libre/4.4-i686.conf \
234 gnu/packages/aux-files/linux-libre/4.4-x86_64.conf \
235 gnu/packages/aux-files/linux-libre/4.1-i686.conf \
236 gnu/packages/aux-files/linux-libre/4.1-x86_64.conf
237
238 # Templates, examples.
239 EXAMPLES = \
240 gnu/system/examples/bare-bones.tmpl \
241 gnu/system/examples/desktop.tmpl \
242 gnu/system/examples/lightweight-desktop.tmpl \
243 gnu/system/examples/vm-image.tmpl
244
245 GOBJECTS = $(MODULES:%.scm=%.go) guix/config.go $(dist_noinst_DATA:%.scm=%.go)
246
247 nobase_dist_guilemodule_DATA = \
248 $(MODULES) $(MODULES_NOT_COMPILED) $(AUX_FILES) $(EXAMPLES) \
249 $(MISC_DISTRO_FILES)
250 nobase_nodist_guilemodule_DATA = guix/config.scm
251 nobase_nodist_guileobject_DATA = $(GOBJECTS)
252
253 # Do we need to provide our own non-broken (srfi srfi-37) module?
254 if INSTALL_SRFI_37
255
256 nobase_nodist_guilemodule_DATA += srfi/srfi-37.scm
257 GOBJECTS += srfi/srfi-37.go
258
259 srfi/srfi-37.scm: srfi/srfi-37.scm.in
260 $(MKDIR_P) srfi
261 cp "$<" "$@"
262
263 endif INSTALL_SRFI_37
264
265 # Handy way to remove the .go files without removing all the rest.
266 clean-go:
267 -$(RM) -f $(GOBJECTS)
268 @find . -name '*.go' -print | \
269 if test -t 1; then \
270 xargs -r echo -e "\033[31mwarning:\033[0m stray .go files:"; \
271 else \
272 xargs -r echo "warning: stray .go files:"; \
273 fi
274
275
276 # Test extensions; has to be unconditional.
277 TEST_EXTENSIONS = .scm .sh
278
279 if CAN_RUN_TESTS
280
281 SCM_TESTS = \
282 tests/base16.scm \
283 tests/base32.scm \
284 tests/base64.scm \
285 tests/cpio.scm \
286 tests/hash.scm \
287 tests/pk-crypto.scm \
288 tests/pki.scm \
289 tests/sets.scm \
290 tests/modules.scm \
291 tests/gnu-maintenance.scm \
292 tests/substitute.scm \
293 tests/builders.scm \
294 tests/derivations.scm \
295 tests/grafts.scm \
296 tests/ui.scm \
297 tests/records.scm \
298 tests/upstream.scm \
299 tests/combinators.scm \
300 tests/discovery.scm \
301 tests/utils.scm \
302 tests/build-utils.scm \
303 tests/packages.scm \
304 tests/snix.scm \
305 tests/hackage.scm \
306 tests/cran.scm \
307 tests/elpa.scm \
308 tests/texlive.scm \
309 tests/store.scm \
310 tests/monads.scm \
311 tests/gexp.scm \
312 tests/nar.scm \
313 tests/union.scm \
314 tests/profiles.scm \
315 tests/search-paths.scm \
316 tests/syscalls.scm \
317 tests/gremlin.scm \
318 tests/bournish.scm \
319 tests/lint.scm \
320 tests/publish.scm \
321 tests/scripts.scm \
322 tests/size.scm \
323 tests/graph.scm \
324 tests/challenge.scm \
325 tests/cache.scm \
326 tests/cve.scm \
327 tests/workers.scm \
328 tests/zlib.scm \
329 tests/file-systems.scm \
330 tests/system.scm \
331 tests/services.scm \
332 tests/scripts-build.scm \
333 tests/containers.scm \
334 tests/pack.scm \
335 tests/import-utils.scm
336
337 if HAVE_GUILE_JSON
338
339 SCM_TESTS += \
340 tests/pypi.scm \
341 tests/cpan.scm \
342 tests/gem.scm \
343 tests/crate.scm
344
345 endif
346
347 SH_TESTS = \
348 tests/guix-build.sh \
349 tests/guix-download.sh \
350 tests/guix-gc.sh \
351 tests/guix-hash.sh \
352 tests/guix-package.sh \
353 tests/guix-package-net.sh \
354 tests/guix-system.sh \
355 tests/guix-archive.sh \
356 tests/guix-authenticate.sh \
357 tests/guix-environment.sh \
358 tests/guix-environment-container.sh \
359 tests/guix-graph.sh \
360 tests/guix-lint.sh
361
362 if BUILD_DAEMON
363
364 SH_TESTS += tests/guix-register.sh
365
366 endif BUILD_DAEMON
367
368
369 TESTS = $(SCM_TESTS) $(SH_TESTS)
370
371 AM_TESTS_ENVIRONMENT = abs_top_srcdir="$(abs_top_srcdir)" GUILE_AUTO_COMPILE=0
372
373 SCM_LOG_DRIVER = \
374 $(top_builddir)/test-env --quiet-stderr \
375 $(GUILE) --no-auto-compile -e main \
376 $(top_srcdir)/build-aux/test-driver.scm
377
378 AM_SCM_LOG_DRIVER_FLAGS = --brief=yes
379
380 SH_LOG_COMPILER = $(top_builddir)/test-env $(SHELL)
381 AM_SH_LOG_FLAGS = -x -e
382
383 # Make sure `tests/guix-gc.sh' runs last, after all the others. Otherwise it
384 # could end up removing files from the store while they are being used by
385 # other instances of the daemon.
386 tests/guix-gc.log: \
387 $(patsubst %.sh,%.log,$(filter-out tests/guix-gc.sh,$(SH_TESTS))) \
388 $(SCM_TESTS:%.scm=%.log)
389
390 else !CAN_RUN_TESTS
391
392 TESTS =
393 SH_TESTS =
394 SCM_TESTS =
395
396 # Automake always generates a 'check' target, so better not override it.
397 check-local:
398 @echo
399 @echo "Cannot run tests because file name limits would be exceeded." >&2
400 @echo "Look for 'length' in the 'config.log' file for details." >&2
401 @echo
402 @exit 1
403
404 endif !CAN_RUN_TESTS
405
406 check-system: $(GOBJECTS) $(BOOTSTRAP_GUILE_TARBALLS)
407 $(AM_V_at)$(top_builddir)/pre-inst-env \
408 $(GUILE) --no-auto-compile \
409 -e '(@@ (run-system-tests) run-system-tests)' \
410 $(top_srcdir)/build-aux/run-system-tests.scm
411
412 # Public key used to sign substitutes from hydra.gnu.org & co.
413 dist_pkgdata_DATA = \
414 hydra.gnu.org.pub \
415 bayfront.guixsd.org.pub
416
417 # Bash completion file.
418 dist_bashcompletion_DATA = etc/completion/bash/guix
419
420 # Zsh completion file.
421 dist_zshcompletion_DATA = etc/completion/zsh/_guix
422
423 EXTRA_DIST = \
424 HACKING \
425 ROADMAP \
426 TODO \
427 CODE-OF-CONDUCT \
428 .dir-locals.el \
429 build-aux/build-self.scm \
430 build-aux/compile-all.scm \
431 build-aux/hydra/evaluate.scm \
432 build-aux/hydra/gnu-system.scm \
433 build-aux/hydra/guix.scm \
434 build-aux/check-available-binaries.scm \
435 build-aux/check-final-inputs-self-contained.scm \
436 build-aux/download.scm \
437 build-aux/generate-authors.scm \
438 build-aux/test-driver.scm \
439 build-aux/update-guix-package.scm \
440 build-aux/update-NEWS.scm \
441 build-aux/run-system-tests.scm \
442 d3.v3.js \
443 graph.js \
444 srfi/srfi-37.scm.in \
445 srfi/srfi-64.scm \
446 srfi/srfi-64.upstream.scm \
447 tests/test.drv \
448 tests/signing-key.pub \
449 tests/signing-key.sec \
450 tests/cve-sample.xml \
451 build-aux/config.rpath \
452 bootstrap \
453 release.nix \
454 $(TESTS)
455
456 if !BUILD_DAEMON_OFFLOAD
457
458 EXTRA_DIST += \
459 guix/scripts/offload.scm
460
461 endif !BUILD_DAEMON_OFFLOAD
462
463
464 CLEANFILES = \
465 $(GOBJECTS) \
466 $(SCM_TESTS:tests/%.scm=%.log)
467
468 # Unset 'GUILE_LOAD_COMPILED_PATH' altogether while compiling. Otherwise, if
469 # $GUILE_LOAD_COMPILED_PATH contains $(moduledir), we may find .go files in
470 # there that are newer than the local .scm files (for instance because the
471 # user ran 'make install' recently). When that happens, we end up loading
472 # those previously-installed .go files, which may be stale, thereby breaking
473 # the whole thing. Likewise, set 'XDG_CACHE_HOME' to avoid loading possibly
474 # stale files from ~/.cache/guile/ccache.
475 %.go: make-go ; @:
476 make-go: $(MODULES) guix/config.scm $(dist_noinst_DATA)
477 $(AM_V_at)echo "Compiling Scheme modules..." ; \
478 unset GUILE_LOAD_COMPILED_PATH ; \
479 XDG_CACHE_HOME=/nowhere \
480 host=$(host) srcdir="$(top_srcdir)" \
481 $(top_builddir)/pre-inst-env \
482 $(GUILE) -L "$(top_builddir)" -L "$(top_srcdir)" \
483 --no-auto-compile \
484 -s "$(top_srcdir)"/build-aux/compile-all.scm $^
485
486 SUFFIXES = .go
487
488 # Make sure source files are installed first, so that the mtime of
489 # installed compiled files is greater than that of installed source
490 # files. See
491 # <http://lists.gnu.org/archive/html/guile-devel/2010-07/msg00125.html>
492 # for details.
493 guix_install_go_files = install-nobase_nodist_guileobjectDATA
494 $(guix_install_go_files): install-nobase_dist_guilemoduleDATA
495
496 # The above trick doesn't work for 'config.go' because both 'config.scm' and
497 # 'config.go' are listed in $(nobase_nodist_guileobject_DATA). Thus, give it
498 # special treatment.
499 install-data-hook: set-bootstrap-executable-permissions
500 touch "$(DESTDIR)$(guileobjectdir)/guix/config.go"
501
502
503 SUBDIRS = po/guix po/packages
504 BUILT_SOURCES =
505
506 include doc/local.mk
507
508 if BUILD_DAEMON
509
510 include nix/local.mk
511
512 endif BUILD_DAEMON
513
514 ACLOCAL_AMFLAGS = -I m4
515
516 # Pass an explicit '--localstatedir' so that configure does not error out if
517 # it finds an existing installation with a different localstatedir. Inherit
518 # 'ac_cv_guix_test_root' so that "make check" in $(distdir) does not have to
519 # repopulate the whole store, and to make sure $(GUIX_TEST_ROOT) is short
520 # enough for shebangs.
521 AM_DISTCHECK_CONFIGURE_FLAGS = \
522 --localstatedir="$$dc_install_base/var" \
523 --with-libgcrypt-prefix="$(LIBGCRYPT_PREFIX)" \
524 --with-libgcrypt-libdir="$(LIBGCRYPT_LIBDIR)" \
525 --with-nix-prefix="$(NIX_PREFIX)" \
526 --enable-daemon \
527 ac_cv_guix_test_root="$(GUIX_TEST_ROOT)"
528
529 # The self-contained tarball. Add 'glibc-utf8-locales' along with glibc just
530 # so 'etc/profile' defines 'GUIX_LOCPATH' pointing to a valid set of locales.
531 guix-binary.%.tar.xz:
532 $(AM_V_GEN)GUIX_PACKAGE_PATH= \
533 tarball=`$(top_builddir)/pre-inst-env guix pack -K -C xz \
534 -s "$*" --localstatedir guix glibc-utf8-locales \
535 -e '(@@ (gnu packages commencement) glibc-final)'` ; \
536 cp "$$tarball" "$@.tmp" ; mv "$@.tmp" "$@"
537
538
539 dist-hook: $(distdir)/ChangeLog gen-AUTHORS gen-tarball-version
540 dist-hook: assert-no-store-file-names
541
542 distcheck-hook: assert-binaries-available assert-final-inputs-self-contained
543
544 EXTRA_DIST += $(top_srcdir)/.version
545 BUILT_SOURCES += $(top_srcdir)/.version
546 $(top_srcdir)/.version:
547 echo $(VERSION) > "$@-t" && mv "$@-t" "$@"
548
549 gen-tarball-version:
550 echo $(VERSION) > "$(distdir)/.tarball-version"
551
552 gen-ChangeLog $(distdir)/ChangeLog:
553 $(AM_V_GEN)if test -d .git; then \
554 $(top_srcdir)/build-aux/gitlog-to-changelog \
555 > $(distdir)/cl-t; \
556 rm -f $(distdir)/ChangeLog; \
557 mv $(distdir)/cl-t $(distdir)/ChangeLog; \
558 fi
559
560 gen-AUTHORS:
561 $(AM_V_GEN)if test -d .git; then \
562 rm -f "$(distdir)/AUTHORS"; \
563 $(top_builddir)/pre-inst-env "$(GUILE)" \
564 "$(top_srcdir)/build-aux/generate-authors.scm" \
565 "$(top_srcdir)" "$(distdir)/AUTHORS"; \
566 fi
567
568 \f
569 #
570 # Release management.
571 #
572
573 releasedir = release-$(PACKAGE_VERSION)
574
575 PACKAGE_FULL_TARNAME = $(PACKAGE_TARNAME)-$(PACKAGE_VERSION)
576
577 # List of source tarballs produced. This must be kept in sync with the
578 # 'dist-' options of 'AM_INIT_AUTOMAKE' in 'configure.ac'.
579 SOURCE_TARBALLS = \
580 $(foreach ext,tar.gz,$(PACKAGE_FULL_TARNAME).$(ext))
581
582 # Systems supported by Guix.
583 SUPPORTED_SYSTEMS ?= x86_64-linux i686-linux armhf-linux
584
585 # Guix binary tarballs.
586 BINARY_TARBALLS = \
587 $(foreach system,$(SUPPORTED_SYSTEMS),guix-binary.$(system).tar.xz)
588
589 # Systems supported by GuixSD.
590 GUIXSD_SUPPORTED_SYSTEMS ?= x86_64-linux i686-linux
591
592 # Systems for which we build GuixSD VMs.
593 GUIXSD_VM_SYSTEMS ?= x86_64-linux
594
595 # Prefix of the GuixSD installation image file name.
596 GUIXSD_IMAGE_BASE = guixsd-usb-install-$(PACKAGE_VERSION)
597
598 # Prefix of the GuixSD VM image file name.
599 GUIXSD_VM_IMAGE_BASE = guixsd-vm-image-$(PACKAGE_VERSION)
600
601 # Size of the installation image (for x86_64 typically).
602 GUIXSD_INSTALLATION_IMAGE_SIZE ?= 950MiB
603
604 # Size of the VM image (for x86_64 typically).
605 GUIXSD_VM_IMAGE_SIZE ?= 2GiB
606
607 # The release process works in several phases:
608 #
609 # 0. We assume the developer created a 'vX.Y' tag.
610 # 1. Build the source tarball.
611 # 2. Update the 'guix' package so that it corresponds to the 'vX.Y' tag.
612 # 3. Build the binary tarballs for that 'guix' package.
613 # 4. Update the 'guix' package again.
614 # 5. Build the GuixSD installation images. The images will run 'guix'
615 # corresponding to 'vX.Y' + 1 commit, and they will install 'vX.Y'.
616 #
617 # This 'release' target takes care of everything and copies the resulting
618 # files to $(releasedir).
619 #
620 # XXX: Depend on 'dist' rather than 'distcheck' to work around the Gettext
621 # issue described at <https://savannah.gnu.org/bugs/index.php?51027>.
622 release: dist
623 cd po; git checkout .
624 @if ! git diff-index --quiet HEAD; then \
625 echo "There are uncommitted changes; stopping." >&2 ; \
626 exit 1 ; \
627 fi
628 $(MKDIR_P) "$(releasedir)"
629 rm -f "$(releasedir)"/*
630 mv $(SOURCE_TARBALLS) "$(releasedir)"
631 $(top_builddir)/pre-inst-env "$(GUILE)" \
632 $(top_srcdir)/build-aux/update-guix-package.scm \
633 "`git rev-parse HEAD`" "$(PACKAGE_VERSION)"
634 git add $(top_srcdir)/gnu/packages/package-management.scm
635 git commit -m "gnu: guix: Update to $(PACKAGE_VERSION)."
636 rm -f $(BINARY_TARBALLS)
637 $(MAKE) $(BINARY_TARBALLS)
638 for system in $(SUPPORTED_SYSTEMS) ; do \
639 mv "guix-binary.$$system.tar.xz" \
640 "$(releasedir)/guix-binary-$(PACKAGE_VERSION).$$system.tar.xz" ; \
641 done
642 $(top_builddir)/pre-inst-env "$(GUILE)" \
643 $(top_srcdir)/build-aux/update-guix-package.scm \
644 "`git rev-parse HEAD`"
645 git add $(top_srcdir)/gnu/packages/package-management.scm
646 git commit -m "gnu: guix: Update to `git rev-parse HEAD | cut -c1-7`."
647 for system in $(GUIXSD_SUPPORTED_SYSTEMS) ; do \
648 image=`$(top_builddir)/pre-inst-env \
649 guix system disk-image \
650 --system=$$system \
651 --image-size=$(GUIXSD_INSTALLATION_IMAGE_SIZE) \
652 gnu/system/install.scm` ; \
653 if [ ! -f "$$image" ] ; then \
654 echo "failed to produced GuixSD installation image for $$system" >&2 ; \
655 exit 1 ; \
656 fi ; \
657 xz < "$$image" > "$(releasedir)/$(GUIXSD_IMAGE_BASE).$$system.xz.tmp" ; \
658 mv "$(releasedir)/$(GUIXSD_IMAGE_BASE).$$system.xz.tmp" \
659 "$(releasedir)/$(GUIXSD_IMAGE_BASE).$$system.xz" ; \
660 done
661 for system in $(GUIXSD_VM_SYSTEMS) ; do \
662 image=`$(top_builddir)/pre-inst-env \
663 guix system vm-image \
664 --system=$$system \
665 --image-size=$(GUIXSD_VM_IMAGE_SIZE) \
666 gnu/system/examples/vm-image.tmpl` ; \
667 if [ ! -f "$$image" ] ; then \
668 echo "failed to produced GuixSD VM image for $$system" >&2 ; \
669 exit 1 ; \
670 fi ; \
671 xz < "$$image" > "$(releasedir)/$(GUIXSD_VM_IMAGE_BASE).$$system.xz.tmp" ; \
672 mv "$(releasedir)/$(GUIXSD_VM_IMAGE_BASE).$$system.xz.tmp" \
673 "$(releasedir)/$(GUIXSD_VM_IMAGE_BASE).$$system.xz" ; \
674 done
675 @echo
676 @echo "Congratulations! All the release files are now in $(releasedir)."
677 @echo
678
679 update-guix-package:
680 git rev-parse HEAD
681 $(top_builddir)/pre-inst-env "$(GUILE)" \
682 $(top_srcdir)/build-aux/update-guix-package.scm \
683 "`git rev-parse HEAD`"
684
685 # Location of a checkout of <git://git.savannah.gnu.org/guix/maintenance.git>.
686 # Package data from this checkout is used by 'update-NEWS.scm'.
687 GUIX_MAINTENANCE_DIRECTORY ?= $(top_srcdir)/../guix-maintenance
688
689 update-NEWS: $(GOBJECTS)
690 $(top_builddir)/pre-inst-env "$(GUILE)" \
691 $(top_srcdir)/build-aux/update-NEWS.scm \
692 $(top_srcdir)/NEWS "$(GUIX_MAINTENANCE_DIRECTORY)/data"
693
694 # Make sure we're not shipping a file that embeds a local /gnu/store file name.
695 assert-no-store-file-names: $(distdir)/ChangeLog
696 $(AM_V_at)if grep -r --exclude=*.texi --exclude=*.info \
697 --exclude=*.info-[0-9] --exclude=*.dot \
698 --exclude=*.eps --exclude-dir=bootstrap \
699 --exclude=guix-prettify.el \
700 --exclude=ChangeLog \
701 -E "$(storedir)/[a-z0-9]{32}-" $(distdir) ; \
702 then \
703 echo "error: store file names embedded in the distribution" >&2 ; \
704 exit 1 ; \
705 fi
706
707 # Make sure hydra.gnu.org has the important binaries.
708 assert-binaries-available: $(GOBJECTS)
709 $(AM_V_at)$(top_builddir)/pre-inst-env "$(GUILE)" \
710 "$(top_srcdir)/build-aux/check-available-binaries.scm"
711
712 # Make sure the final inputs don't refer to bootstrap tools.
713 assert-final-inputs-self-contained: $(GOBJECTS)
714 $(AM_V_at)$(top_builddir)/pre-inst-env "$(GUILE)" \
715 "$(top_srcdir)/build-aux/check-final-inputs-self-contained.scm"
716
717 # Compute the Hydra jobs and write them in the target file.
718 hydra-jobs.scm: $(GOBJECTS)
719 $(AM_V_at)$(MKDIR_P) "`dirname "$@"`"
720 $(AM_V_GEN)$(top_builddir)/pre-inst-env "$(GUILE)" \
721 "$(top_srcdir)/build-aux/hydra/evaluate.scm" \
722 "$(top_srcdir)/build-aux/hydra/gnu-system.scm" > "$@.tmp"
723 $(AM_V_at)mv "$@.tmp" "$@"
724
725 .PHONY: gen-ChangeLog gen-AUTHORS gen-tarball-version
726 .PHONY: assert-no-store-file-names assert-binaries-available
727 .PHONY: assert-final-inputs-self-contained
728 .PHONY: clean-go make-go
729 .PHONY: update-guix-package update-NEWS release
730
731 ## -------------- ##
732 ## Silent rules. ##
733 ## -------------- ##
734
735 AM_V_DL = $(AM_V_DL_$(V))
736 AM_V_DL_ = $(AM_V_DL_$(AM_DEFAULT_VERBOSITY))
737 AM_V_DL_0 = @echo " DL " $@;
738
739 AM_V_DOT = $(AM_V_DOT_$(V))
740 AM_V_DOT_ = $(AM_V_DOT_$(AM_DEFAULT_VERBOSITY))
741 AM_V_DOT_0 = @echo " DOT " $@;
742
743 AM_V_HELP2MAN = $(AM_V_HELP2MAN_$(V))
744 AM_V_HELP2MAN_ = $(AM_V_HELP2MAN_$(AM_DEFAULT_VERBOSITY))
745 AM_V_HELP2MAN_0 = @echo " HELP2MAN" $@;